# frozen_string_literal: true

require 'ffi'

module Nt
  # Fingerprint converts queries to fingerprints.
  module Fingerprint
    extend FFI::Library

    platform = `uname -sm`

    file = case platform
           when /^Linux.*64/
             'libfp-linux-amd64.so'
           when /^Darwin.*64/
             'libfp-darwin-10.6-amd64.dylib'
           else
             abort 'nt-fingerprint does not support your platform.'
           end

    ffi_lib File.expand_path("../../../go/build/#{file}", __dir__)
    attach_function :fingerprint, [:string], :string
  end
end
